<template>
  <div>
    <img src="@/assets/logo.png" id="logo" />
    <el-form ref="loginForm" id="login_form" :model="loginForm">
      <el-form-item>
        <el-input class="login_input" v-model="loginForm.email" placeholder="Email"></el-input>
      </el-form-item>
      <el-form-item>
        <el-input class="login_input" v-model="loginForm.password" placeholder="Password" show-password @keydown.enter.native="login"></el-input>
      </el-form-item>
      <el-button id="login_button" round @click="login">{{ $t('LOGIN.LOGIN_BUTTON') }}</el-button>
      <br>
      <el-button id="login_button2" round @click="loginGuest">{{ $t('LOGIN.LOGIN_GUEST') }}</el-button>
      <el-form-item>
        <el-row>
          <el-col :span="12">
            <el-checkbox v-model="loginForm.stay_logged_in" id="login_checkbox">
              {{ $t('LOGIN.KEEP_LOGIN') }}
            </el-checkbox>
          </el-col>
          <el-col :span="12">
            <div id="findPassword" @click="findPassword">
              {{ $t('LOGIN.FORGOT_PASSWORD_BUTTON') }}
            </div>
          </el-col>
        </el-row>
      </el-form-item>
      <div id="register">
        <el-row style="margin: 0">
          <el-col :span="14"> {{ $t('LOGIN.NEW_PRESWOT') }} </el-col>
          <el-col :span="10">
            <!-- <router-link class="link link_right blue" :to="{ name: 'Register' }"
              >{{ $t('LOGIN.CREATE_ACCOUNT') }}</router-link
            > -->
            <div
              class="link link_right blue" @click="createAccount">
              {{ $t('LOGIN.CREATE_ACCOUNT') }}
            </div>
          </el-col>
        </el-row>
      </div>
    </el-form>
    <el-dialog
      :title="$t('LOGIN.LOGIN_REQUIRED')"
      :visible.sync="isModalVisible"
      :width="`${$isPhone ? '80' : '30'}%`"
      center
    >
      <el-form label-width="120px" label-position="top">
        <el-form-item :label="$t('LOGIN.CHANGE_PASSWORD_EMAIL')">
          <el-input
            v-model="findingPasswordEmail"
            class="LoginFindingPasswordEmail"
          ></el-input>
        </el-form-item>
      </el-form>
      <span slot="footer" class="dialog-footer">
        <el-button
          type="primary"
          class="LoginSendTemporaryPassword"
        >
          {{ $t("LOGIN.SEND_CHANGE_PASSWORD_METHOD") }}
        </el-button>
      </span>
    </el-dialog>
    <el-dialog
      :title="$t('REG.REG_TITLE')"
      :visible.sync="isRegVisible"
      :width="`${$isPhone ? '80' : '40'}%`"
      id="register_wrapper"
      :close-on-click-modal="false"
      :close-on-press-escape="false"
      center>
        <el-form
          :rules="rules"
          ref="elForm"
          :model="input"
          :label-width="getLabelWidth()"
        >
          <el-form-item :label="$t('REG.USER_TYPE_LABEL')" prop="type" id="type">
            <el-radio-group v-model="input.type" id="user_type_input">
              <el-radio-button label="0">{{
                $t("REG.USER_TYPE_STU")
              }}</el-radio-button>
              <el-radio-button label="1">{{
                $t("REG.USER_TYPE_INST")
              }}</el-radio-button>
            </el-radio-group>
          </el-form-item>
          <br/>

          <el-form-item
            :label="$t('REG.EMAIL_LABEL')"
            prop="email_id"
            id="email_id"
          >
            <el-input
              :placeholder="$t('REG.EMAIL_PH')"
              v-model="input.email_id"
              type="email"
              class="register-input"
            ></el-input>
          </el-form-item>
          <br/>

          <el-form-item
            :label="$t('REG.PASSWORD_LABEL')"
            prop="password"
            id="password"
          >
            <el-input
              :placeholder="$t('LOGIN.PASSWORD_PH')"
              v-model="input.password"
              type="password"
              class="register-input"
            ></el-input>
            <br />
            <div id="passwordHelp">{{ $t("REG.PASSWORD_HELP1") }}</div>
          </el-form-item>
          <br/>

          <el-form-item
            :label="$t('REG.PASSWORD_CHECK_LABEL')"
            prop="password2"
            id="password2"
          >
            <el-input
              :placeholder="$t('LOGIN.PASSWORD_PH')"
              v-model="input.password2"
              type="password"
              class="register-input"
            ></el-input>
          </el-form-item>
          <br/>

          <el-form-item :label="$t('REG.NAME_LABEL')" prop="name" id="name">
            <el-input
              :placeholder="$t('REG.NAME_PH')"
              v-model="input.name"
              type="string"
              class="register-input"
            >
            </el-input>
          </el-form-item>
          <br/>

          <el-form-item :label="$t('REG.SEX_LABEL')" prop="sex" id="sex">
            <el-radio-group v-model="input.sex" id="user_sex_input">
              <el-radio-button label="0">{{
                $t("REG.SEX_LABEL_MALE")
              }}</el-radio-button>
              <el-radio-button label="1">{{
                $t("REG.SEX_LABEL_FEMALE")
              }}</el-radio-button>
            </el-radio-group>
          </el-form-item>
          <br/>

          <el-form-item :label="$t('REG.BIRTHDAY_LABEL')" prop="birth" id="birth">
            <el-date-picker
              :placeholder="$t('REG.BIRTHDAY_PH')"
              v-model="input.birth"
              type="date"
              id="user_birthday_input"
            >
            </el-date-picker>
          </el-form-item>
          <br/>
          <el-form-item
            :label="$t('REG.PHONE_NUMBER_LABEL')"
            prop="phone"
            id="phone"
          >
            <el-input
              :placeholder="$t('REG.PHONE_NUMBER_PH')"
              v-model="input.phone"
              v-mask="['###-####-####', '###-###-####']"
              type="tel"
              class="register-input"
            ></el-input>
          </el-form-item>
          <br />

          <el-form-item>
            <el-button
              style="
                width: 250px;
                height: 50px;
                background: navy;
                border: 0px;
                font-weight: 700;
              "
              class="register-button"
              id="btn_submit_register"
              type="primary"
              @click="submitForm('elForm')"
              >회원가입</el-button
            >
          </el-form-item>
        </el-form>
    </el-dialog>
  </div>
</template>

<script>
import { mapActions, mapState } from "vuex";
import Register from '../pages/v4_register';
import generateRules from "../../validations/registerValidation";
import authService from "../../services/authService";

export default {
  name: "v4_login",
  data() {
    const vm = this;
    const initialInput = {
      type: "0",
      email_id: "",
      password: "",
      password2: "",
      name: "",
      birth: "",
      postcode: "",
      address1: "", // 지역 주소
      address2: "", // 상세 주소
      phone: "",
      major: "",
      belong: "",
      sex: "0",
      dialogImageUrl: "",
      dialogVisible: false,
      fileData: "",
    }
    return {
      loginForm: {
        email: "",
        password: "",
        stay_logged_in: false,
      },
      isModalVisible: false,
      findingPasswordEmail: '',
      isRegVisible: false,
      focused: false,
      input: initialInput,
      initialInput,
      rules: generateRules(vm),
    };
  },
  componenets: {
    Register,
  },
  computed: {
    ...mapState("auth", ["locale"]),
    address() {
      const vm = this;
      const address = `${vm.input.address1} ${vm.input.address2} ${vm.input.postcode}`;
      return address.trim();
    },
  },
  methods: {
    ...mapActions("auth", ["reqLogin", "findPassword"]),
    processFile(event) {
      this.fileData = event.target.files[0];
    },

    async doUpload() {
      const form = new FormData();
      form.append("uploadFile", this.fileData);
      form.append("email_id", this.input.email_id);
      // await userService.postUserProfile(form);
    },
    handleRemove(file, fileList) {
      // console.log(file, fileList);
    },
    handlePictureCardPreview(file) {
      this.dialogImageUrl = file.url;
      this.dialogVisible = true;
    },
    execDaumPostcode() {
      const vm = this;
      new window.daum.Postcode({
        // 팝업에서 검색결과 항목을 클릭했을때 실행할 코드를 작성하는 부분.
        oncomplete(data) {
          // 각 주소의 노출 규칙에 따라 주소를 조합한다.
          // 내려오는 변수가 값이 없는 경우엔 공백('')값을 가지므로, 이를 참고하여 분기 한다.
          let fullAddr = ""; // 최종 주소 변수
          let extraAddr = ""; // 조합형 주소 변수

          // 사용자가 선택한 주소 타입에 따라 해당 주소 값을 가져온다.
          if (data.userSelectedType === "R") {
            // 사용자가 도로명 주소를 선택했을 경우
            fullAddr = data.roadAddress;
          } else {
            // 사용자가 지번 주소를 선택했을 경우(J)
            fullAddr = data.jibunAddress;
          }

          // 사용자가 선택한 주소가 도로명 타입일때 조합한다.
          if (data.userSelectedType === "R") {
            // 법정동명이 있을 경우 추가한다.
            if (data.bname !== "") {
              extraAddr += data.bname;
            }
            // 건물명이 있을 경우 추가한다.
            if (data.buildingName !== "") {
              extraAddr +=
                extraAddr !== "" ? `, ${data.buildingName}` : data.buildingName;
            }
            // 조합형주소의 유무에 따라 양쪽에 괄호를 추가하여 최종 주소를 만든다.
            fullAddr += extraAddr !== "" ? ` (${extraAddr})` : "";
          }

          // 우편번호와 주소 정보를 해당 필드에 넣는다.
          vm.input.postcode = data.zonecode; // 5자리 새우편번호 사용
          vm.input.address1 = fullAddr;

          // 커서를 상세주소 필드로 이동한다.
          document.getElementById("detail").focus();
        },
      }).open();
    },
    validator(formName, element) {
      const vm = this;
      let isValid = true;
      vm.$refs[formName].validateField(element, async (e) => {
        if (e) {
          vm.$scrollTo("#" + element, 500, {
            offset: -100,
          });
          isValid = false;
        }
      });
      return isValid;
    },
    async submitForm(formName) {
      const vm = this;

      const fieldList = [
        "type",
        "email_id",
        "password",
        "password2",
        "name",
        "birth",
        "sex",
      ];

      let allValid = true;
      for (let i = 0; i < fieldList.length; i += 1) {
        if (!vm.validator(formName, fieldList[i])) {
          allValid = false;
          break;
        }
      }
      if (!allValid) {
        // console.log("error submit!!"); // eslint-disable-line
        return;
      }
      try {
        if (vm.input.birth === "") {
          vm.input.birth = null;
        }
        await authService.register({
          input: {
            ...vm.input,
            address: vm.address,
          },
        });
        vm.input = vm.initialInput;
        vm.isRegVisible = false;
        vm.$notify({
          title: vm.$t('REG.REG_TITLE'),
          message: vm.$t('REG.SUCCESS'),
          type: "success",
          duration: 5000,
        })
      } catch (e) {
        if (e.message === "Request failed with status code 409") {
          vm.$notify({
            title: vm.$t('REG.REG_TITLE'),
            message: vm.$t('REG.ERR_DUPLICATED_EMAIL'),
            type: "error",
            duration: 5000,
          });
        } else {
          throw new Error("request error");
        }
      }
      
    },
    getLabelWidth() {
      const vm = this;
      const labelString = [
        vm.$t("REG.EMAIL_LABEL"),
        vm.$t("REG.PASSWORD_LABEL"),
        vm.$t("REG.PASSWORD_CHECK_LABEL"),
        vm.$t("REG.NAME_LABEL"),
        vm.$t("REG.BIRTHDAY_LABEL"),
        vm.$t("REG.SEX_LABEL"),
        vm.$t("REG.ADDRESS_LABEL"),
        vm.$t("REG.ADDRESS2_LABEL"),
        vm.$t("REG.PHONE_NUMBER_LABEL"),
        vm.$t("REG.MAJOR_LABEL"),
        vm.$t("REG.BELONG_LABEL"),
        vm.$t("REG.TOU"),
      ];
      const maxLabelLength =
        Math.max.apply(
          null,
          labelString.map((x) => x.length)
        ) + 5;

      let charPixel = 15;
      switch (vm.locale) {
        default:
        case "ko":
          charPixel = 15;
          break;
        case "en":
          charPixel = 8;
          break;
      }
      const width = maxLabelLength * charPixel + "px"; // eslint-disable-line

      return width;
    },
    findPassword() {
      const vm = this;

      vm.isModalVisible = true;
    },
    createAccount() {
      const vm = this;

      vm.isRegVisible = true;
    },
    async login() {
      const vm = this;
      try {
        const res = await vm.reqLogin({
          permanent: vm.loginForm.stay_logged_in,
          email: vm.loginForm.email,
          password: vm.loginForm.password,
        });

        if (res.data.terms === 0) {
          vm.$router.push({ name: "NNTos" });
        } else {
          vm.$router.push({ name: "LandingPage" }).catch(() => {});
        }
      } catch (error) {
        if (error.response.status === 403) {
          vm.$notify({
            title: "warning",
            message: vm.$t("NOTIFY.ACCNT_NOT_EXIST"),
            type: "warning",
            duration: 5000,
          });
        } else if (error.response.status === 406) {
          vm.$notify({
            title: "Sorry",
            message: vm.$t("NOTIFY.INCORR_PSWRD"),
            type: "warning",
            duration: 5000,
          });
        } else {
          vm.$notify({
            title: "Sorry",
            message:
              error.response !== undefined
                ? error.response.data.message
                : error.message, //eslint-disable-line
            type: "warning",
            duration: 5000,
          });
        }
      }
    },
    async loginGuest() {
      const vm = this;
      const res = await vm.reqLogin({
          permanent: false,
          email: 'guest',
          password: 'test',
        });
        vm.$router.push({ name: "LandingPage" }).catch(() => {});
    },
  },
};
</script>

<style scoped>
#passwordHelp{
  font-size: 12px;
}
.el-row {
  margin: 0;
}

.register-input {
  width: 450px;
}

.register-button {
  margin-left: 10px;
}

.tos {
  background-color: white;
  border-radius: 4px;
  padding: 10px;
}

.file_input_textbox {
  float: left;
  height: 35px;
  width: 200px;
  border: 1px solid lightgrey;
  border-radius: 5px;
}
.file_input_div {
  position: relative;
  width: 100px;
  height: 40px;
  overflow: hidden;
}
.file_input_button {
  width: 100px;
  height: 40px;
  position: absolute;
  top: 0px;
  background-color: #2497d8;
  color: #fff;
  border-style: solid;
  border-radius: 5px;
}
.file_input_hidden {
  font-size: 50px;
  margin-left: 5px;
  position: absolute;
  right: 0px;
  top: 0px;
  opacity: 0;
  filter: alpha(opacity=0);
  -ms-filter: "alpha(opacity=0)";
  -khtml-opacity: 0;
  -moz-opacity: 0;
}

#logo {
  margin-left: 37.5vw;
  margin-top: 25vh;
  width: 25vw;
}
.login_input >>> .el-input__inner {
  border-radius: 20px;
  padding-left: 1.5vw;
  padding-right: 1.5vw;
  width: 100%;
}
#login_form {
  margin-top: 3vh;
  width: 22vw;
  margin-left: 39vw;
}
.el-form-item {
  margin: 0 0 1vh;
}
#login_button {
  width: 100%;
  margin-top: 2vh;
  background: #4366ac;
  color: white;
  font-size: 1.1em;
}
#login_button2 {
  width: 100%;
  margin-top: 0.5vh;
  background: #999999;
  color: white;
  font-size: 1.1em;
}
.link_right {
  width: 100%;
  text-align: right;
  display: inline-block;
}
#findPassword {
  text-align: right;
  cursor: pointer;
  margin-right: 10px;
}
#findPassword:hover {
  color: #409eff;
}
.link {
  color: black;
  text-decoration: none;
  cursor: pointer;
}
.link:hover {
  color: #409eff;
}
#login_checkbox {
  margin-left: 0.5vw;
}
#register {
  border-radius: 5px;
  padding: 1vh 1vw;
  font-size: 0.9em;
  border: 1px solid #4366ac;
}
.blue {
  color: #4366ac;
}
</style>